﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WinGridEnableAddedRows
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable table = new DataTable();
            table.Columns.Add("Project", typeof(string)).DefaultValue = "Project1";
            table.Columns.Add("Milestone", typeof(string)).DefaultValue = "Milestone0";
            table.Columns.Add("Class", typeof(string)).DefaultValue = "Class2";

            table.Columns.Add("Sunday", typeof(double)).DefaultValue = 0.0D;
            table.Columns.Add("Monday", typeof(double)).DefaultValue = 0.0D;
            table.Columns.Add("Tuesday", typeof(double)).DefaultValue = 0.0D;
            table.Columns.Add("Wednesday", typeof(double)).DefaultValue = 0.0D;
            table.Columns.Add("Thursday", typeof(double)).DefaultValue = 0.0D;
            table.Columns.Add("Friday", typeof(double)).DefaultValue = 0.0D;
            table.Columns.Add("Saturday", typeof(double)).DefaultValue = 0.0D;

            table.Rows.Add(); table.Rows.Add();
            table.Rows.Add();
            table.Rows.Add();

            ultraGrid1.DataSource = table;
            ultraGrid1.DisplayLayout.PerformAutoResizeColumns(true, PerformAutoSizeType.AllRowsInBand);

        }

        private void ultraNumericEditor1_KeyPress(object sender, KeyPressEventArgs e)
        {
            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowAddNew = AllowAddNew.TemplateOnBottom;

            e.Layout.Bands[0].Columns["Project"].ValueList = GenerateList("Project");
            e.Layout.Bands[0].Columns["Milestone"].ValueList = GenerateList("Milestone");
            e.Layout.Bands[0].Columns["Class"].ValueList = GenerateList("Class");

            e.Layout.Bands[0].Columns["Sunday"].EditorComponent = ultraNumericEditor1;
            e.Layout.Bands[0].Columns["Monday"].EditorComponent = ultraNumericEditor1;
            e.Layout.Bands[0].Columns["Tuesday"].EditorComponent = ultraNumericEditor1;
            e.Layout.Bands[0].Columns["Wednesday"].EditorComponent = ultraNumericEditor1;
            e.Layout.Bands[0].Columns["Thursday"].EditorComponent = ultraNumericEditor1;
            e.Layout.Bands[0].Columns["Friday"].EditorComponent = ultraNumericEditor1;
            e.Layout.Bands[0].Columns["Saturday"].EditorComponent = ultraNumericEditor1;

            e.Layout.Bands[0].Override.SummaryDisplayArea = SummaryDisplayAreas.BottomFixed;
          
            e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Sunday"]).DisplayFormat = "Sunday Total {0}";
            e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Monday"]).DisplayFormat = "Monday Total {0}";
            e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Tuesday"]).DisplayFormat = "Tuesday Total {0}";
            e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Wednesday"]).DisplayFormat = "Wednesday Total {0}";
            e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Thursday"]).DisplayFormat = "Thursday Total {0}";
            e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Friday"]).DisplayFormat = "Friday Total {0}";
            e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Saturday"]).DisplayFormat = "Saturday Total {0}";

            e.Layout.Bands[0].SummaryFooterCaption = "Sum for the weekend";
           
            e.Layout.Bands[0].Override.AutoResizeColumnWidthOptions = AutoResizeColumnWidthOptions.IncludeSummaryRows;
            e.Layout.Bands[0].Override.ColumnAutoSizeMode = ColumnAutoSizeMode.AllRowsInBand;
            
            
        }

        private void ultraGrid1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (ultraGrid1.ActiveCell.EditorResolved is EditorWithMask)
            {
                EditorWithMask mask = (EditorWithMask)ultraGrid1.ActiveCell.EditorResolved;
                if (char.IsDigit(e.KeyChar))
                {
                    double val = double.Parse(mask.Value.ToString() + e.KeyChar.ToString());
                    val = val > 23 ? val / 10 : val;
                    if ((val % 1) > 0.59)
                        e.Handled = true;
                }
                else
                {
                    double val = 0;
                    double.TryParse(mask.Value.ToString(), out val);
                    if (val < 0)
                        return;
                    val = val > 23 ? val / 10 : val;
                    if ((val % 1) > 0.59)
                    {
                        mask.Value = (int)(val / 1);
                        mask.SelectionStart = 3;
                    }
                }

            }
        }

        private ValueList GenerateList(string value)
        {
            ValueList ret = new ValueList();
            for (int i = 0; i < 10; i++)
                ret.ValueListItems.Add(value + i.ToString());
            return ret;
        }

        private void ultraGrid1_BeforeEnterEditMode(object sender, CancelEventArgs e)
        {
            if (ultraGrid1.ActiveCell.Column.Index < 3 && !ultraGrid1.ActiveCell.Row.IsAddRow)
                e.Cancel = true;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if (e.Row.IsAddRow)
            {
                e.Row.Cells["Milestone"].ValueList = GenerateList(e.Row.Cells["Project"].Value.ToString() + "Milestone");
                e.Row.Cells["Class"].ValueList = GenerateList(e.Row.Cells["Milestone"].Value.ToString() + "Class");
            }
        }

    }
}
